class Probasketball
  def self.connect(api_key, options = {})
    self.new(api_key, options)
  end

  def initialize(api_key, options)
    @api_key = api_key
    @options = options
    @api = Probasketball::Api.new(@api_key, @options)
  end

  def teams
    @teams ||= Probasketball::Collections::Teams.new(api)
  end

  def players
    @players ||= Probasketball::Collections::Players.new(api)
  end

  def games
    @games ||= Probasketball::Collections::Games.new(api)
  end

  def shots
    @shots ||= Probasketball::Collections::Shots.new(api)
  end

  def advanced_stats
    @advanced_stats ||= Probasketball::Collections::AdvancedStats.new(api)
  end

  def misc_stats
    @misc_stats ||= Probasketball::Collections::MiscStats.new(api)
  end

  def boxscores
    @boxscores ||= Probasketball::Collections::Boxscores.new(api)
  end

  def four_factors
    @four_factors ||= Probasketball::Collections::FourFactors.new(api)
  end

  def sportsvu_data
    @sportsvu_data ||= Probasketball::Collections::SportsvuData.new(api)
  end

  def usages
    @usages ||= Probasketball::Collections::Usages.new(api)
  end

  private

  def api
    @api
  end

  class ApiError < StandardError
  end
end

require 'probasketball/api'
require 'probasketball/collections/games'
require 'probasketball/collections/players'
require 'probasketball/collections/teams'
require 'probasketball/collections/shots'
require 'probasketball/collections/advanced_stats'
require 'probasketball/collections/four_factors'
require 'probasketball/collections/misc_stats'
require 'probasketball/collections/sportsvu_data'
require 'probasketball/collections/usages'
require 'probasketball/collections/boxscores'
